<?php
/*
Copyright (c) 2006, Jonas Hggqvist
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>People map</title>

<link rel="stylesheet" href="map.css" />

<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php echo file_get_contents('key.txt'); ?>"
      type="text/javascript"></script>
<script src="common.js" type="text/javascript"></script>
<script src="edit.js" type="text/javascript"></script>

<script type="text/javascript">
//<![CDATA[
var map;
var marker;
//]]>
</script>

</head>
<body onload="newload();singleMarker()" onunload="GUnload()">
<h1>Add yourself</h1>
<p><a href='./'>Go back</a>.</p>
<p>There are two ways of determining your location: Using the searchfield below
or using the map at the bottom of the page. If you already know your
coordinates, you can enter them by hand, in the form below.</p>

<h2>Search</h2>
<p>
You can use this field to lookup your coordinates without having to navigate the
map. Works best for North American locations, but might work elsewhere as well.
Specifying your country is a good idea (eg. "Rome, Italy"). Check 
<a href="#maptop">the map below</a> if possible, to verify that the search found
the right location.

</p>
<?php
    $lat = "";
    $lng = "";
    if (isset($_REQUEST['cmd'])) {
        $q = urlencode($_REQUEST['lookup']);
        $key = "ABQIAAAARrXzQu32adyM5ZKIn_g1XhSfl4nbtegwxTw4bux7MAdmigWI6RShBWoEv4luBLzuX417oj4hFNcf4w";
        $output = 'csv';
        $response = file_get_contents(sprintf('http://maps.google.com/maps/geo?q=%s&key=%s&output=%s', $q, $key, $output));
        list($status, $accuracy, $lat, $lng) = explode(",",$response);
        
        $search = htmlspecialchars($_REQUEST['lookup']);
        
        switch($status) {
            case '200': $result = "Found. Latitude: $lat, Longitude: $lng"; break;
            case '500': $result = "Server error"; break;
            case '601': $result = "Empty search"; break;
            case '602': $result = "Not found"; break;
            case '603': $result = "Address unavailable"; break;
            case '610': $result = "Bad Google Maps key"; break;
            default: $result = "Search failed with unknown error"; break;
        }
    }

    echo <<<END
<form name="lookupform" onsubmit="return false" method="post" action="add.php">
<input type="hidden" name="cmd" value="search" />
    Your location: <input type="text" name="lookup" id="lookup" value="$search" />
    <input type="submit" value="Search" id="Search" onclick="findLocation()" />
    <span id="searchresult">$result</span>
</form>
END;

?>

<h2>Details</h2>
<p>
Fill in as many of the details below as you like (the only requirement is you 
have to fill in at least one of alias and full name). You do not have to enter
an email-address. After submitting, you will be given a key that can be used if
you wish to edit your entry later. If you do enter an email, it will give you
the option of retrieving this key if you lose it. I will never use it for
anything but key-retrieval.
</p>

<p>
Note that if you enter the latitude and longitude by hand, it must be in decimal
format (Not degrees, minutes, seconds).
</p>

<table>
    <form method="post" action="save.php">
        <tr>
            <td>Latitude</td>
            <td><input type="text" value="<?php echo $lat; ?>" name="lat" id="lat" onChange='updateCenter()' /></td>
        </tr>
        <tr>
            <td>Longitude</td>
            <td><input type="text" value="<?php echo $lng; ?>" name="lng" id="lng" onChange='updateCenter()' /></td>
        </tr>
        <tr>
            <td>Website</td>
            <td><input type="text" name="url" /> (optional)</td>
        </tr>
        <tr>
            <td>Email</td>
            <td><input type="text" name="email" /> (optional, may be used if you wish to edit your entry later)</td>
        </tr>
        <tr>
            <td>Alias</td>
            <td><input type="text" name="alias" /> (fill either this, Full name or both)</td>
        </tr>
        <tr>
            <td>Full name</td>
            <td><input type="text" name="fullname" /> (fill either this, Alias or both)</td>
        </tr>
        <tr>
            <td>Developer</td>
            <td><input type="checkbox" name="dev" /> (check if you are a Rockbox developer)</td>
        </tr>
        <tr>
            <td align="right" colspan="2"><input type="submit" value="Add yourself" /></td>
        </tr>
    </form>
</table>

<h2>Map</h2>

<p>
Move the map below and marker around using the mouse, until your location is marked by
the marker (you'll probably need to use zoom). You do not have to get it
accurate down to street level (in fact, that's probably not a wise idea), just
getting the city or general area correct will be fine.
</p>

<a name="maptop"></a>
<div id="gmap" style="width: 500px; height: 300px"></div>

<p>
<a href="#maptop" onclick='fullWindow()' id="full">Full window</a>
<a href="#maptop" onclick='smallWindow()' id="small" style="display: none">Small window</a>
</p>

</body>
</html>
