<?php
/*
Copyright (c) 2006, Jonas Hggqvist
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>People map</title>

<link rel="stylesheet" href="map.css" />

<style type="text/css">
</style>

<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php echo file_get_contents('key.txt'); ?>"
      type="text/javascript"></script>
<script src="common.js" type="text/javascript"></script>
<script src="edit.js" type="text/javascript"></script>

<script type="text/javascript">

//<![CDATA[
// Global variables for the map and marker 
var map;
var marker;
//]]>
</script>

</head>

<?php
    // Show the "Edit yourself" page for a user. Includes a huge blob of HTML
    function show_user($id, $user) {
        extract($user);
        if ($dev != "") { $dev = 'checked="checked" '; }
        
        /*
           If the search form was submitted (ie. javascript is disabled),
           perform the lookup server-side. This is mainly here as a convenience
           for blind users, but of course also works for people with javascript
           disabled. 
        */
        if (isset($_REQUEST['cmd'])) {
            $q = urlencode($_REQUEST['lookup']);
            $key = "ABQIAAAARrXzQu32adyM5ZKIn_g1XhSfl4nbtegwxTw4bux7MAdmigWI6RShBWoEv4luBLzuX417oj4hFNcf4w";
            $output = 'csv';
            $response = file_get_contents(sprintf('http://maps.google.com/maps/geo?q=%s&key=%s&output=%s', $q, $key, $output));
            list($status, $accuracy, $lat, $lng) = explode(",",$response);
            
            $search = htmlspecialchars($_REQUEST['lookup']);
            
            switch($status) {
            case '200': $result = "Found. Latitude: $lat, Longitude: $lng"; break;
                case '500': $result = "Server error"; break;
                case '601': $result = "Empty search"; break;
                case '602': $result = "Not found"; break;
                case '603': $result = "Address unavailable"; break;
                case '610': $result = "Bad Google Maps key"; break;
                default: $result = "Search failed with unknown error"; break;
            }
        }
        // Here comes the HTML
        echo <<<END
<body onload="newload();singleMarker()" onunload="GUnload()">
<h1>Edit yourself</h1>

<p><a href='./'>Go back</a>.</p>

<p>There are two ways of determining your location: Using the searchfield below
or using the map at the bottom of the page. If you already know your
coordinates, you can enter them by hand, in the form below.</p>

<h2>Search</h2>
<p>
You can use this field to lookup your coordinates without having to navigate the
map. Works best for North American locations, but might work elsewhere as well.
Specifying your country is a good idea (eg. "Rome, Italy"). Check 
<a href="#maptop">the map below</a> if possible, to verify that the search found
the right location.
</p>

<form name="lookupform" onsubmit="return false" method="post" action="edit.php">
<input type="hidden" name="cmd" value="search" />
<input type="hidden" name="string" value="$id" />
    Your location: <input type="text" name="lookup" id="lookup" value="$search" />
    <input type="submit" value="Search" id="Search" onclick="findLocation()" />
    <span id="searchresult">$result</span>  
</form>

<h2>Details</h2>
<p>
Fill in as many of the details below as you like (the only requirement is you 
have to fill in at least one of alias and full name). You do not have to enter
an email-address. After submitting, you will be given a key that can be used if
you wish to edit your entry later. If you do enter an email, it will give you
the option of retrieving this key if you lose it. I will never use it for
anything but key-retrieval.
</p>

<p>
Note that if you enter the latitude and longitude by hand, it must be in decimal
format (Not degrees, minutes, seconds).
</p>

<table>
    <form method="post" action="save.php">
    <input type="hidden" name="id" value="$id">
        <tr>
            <td>Latitude</td>
            <td><input type="text" name="lat" id="lat" onchange="updateCenter()" value="$lat" /></td>
        </tr>
        <tr>
            <td>Longitude</td>
            <td><input type="text" name="lng" id="lng" onchange="updateCenter()" value="$lng" /></td>
        </tr>
        <tr>
            <td>Website</td>
            <td><input type="text" name="url" value="$url" /> (optional)</td>
        </tr>
        <tr>
            <td>Email</td>
            <td><input type="text" name="email" value="$email" /> (optional, may be used if you wish to edit your entry later)</td>
        </tr>
        <tr>
            <td>Alias</td>
            <td><input type="text" name="alias" value="$alias" /> (fill either this, Full name or both)</td>
        </tr>
        <tr>
            <td>Full name</td>
            <td><input type="text" name="fullname" value="$fullname" /> (fill either this, Alias or both)</td>
        </tr>
        <tr>
            <td>Developer</td>
            <td><input type="checkbox" name="dev" $dev/> (check if you are a Rockbox developer)</td>
        </tr>        
        <tr>
            <td align="right" colspan="2"><input type="submit" value="Update" /></td>
        </tr>
    </form>
</table>

<h2>Map</h2>

<p>
Move the map below and marker around using the mouse, until your location is marked by
the marker (you'll probably need to use zoom). You do not have to get it
accurate down to street level (in fact, that's probably not a wise idea), just
getting the city or general area correct will be fine.
</p>

<a name="maptop"></a>
<div id="gmap" style="width: 500px; height: 300px"></div>
<p>
<a href="#maptop" onclick='fullWindow()' id="full">Full window</a>
<a href="#maptop" onclick='smallWindow()' id="small" style="display: none">Small window</a>
</p>
END;
// And we're done
    }
    
    // Send an email to a user, informing him of his key
    function sendmail($email, $users) {
        echo "<h1>Retrieve key</h1>\n";
        
        foreach($users as $thiskey => $info) {
            if ($info['email'] == $email) {
                if (isset($key)) {
                    echo "<p>More than one entry under this email exists. I will not send an email.</p>\n";
                    echo "<p><a href='./'>Go back</a>.</p>\n";
                    return false;
                }
                $key = $thiskey;
            }
        }
        if (!isset($key)) {
            echo "<p>No entry under this email ($email) exists.</p>\n";
            echo "<p><a href='./'>Go back</a>.</p>\n";
            return false;
        }
        else {
            $ip = $_SERVER['REMOTE_ADDR'];
            
	    $body  = "A user (from the ip $ip) recently requested the key for your entry on\n";
	    $body .= "the People map. If this was not you,\n";
	    $body .= "you can safely ignore this mail. If it was you, you'll be delighted to know,\n";
	    $body .= "that your key is listed below.\n\n    Your key: $key\n\n";
	    
            $subject = "People map key retrieval";
            $headers = "From: People map <no-reply@example.com>";

            if (mail($email, $subject, $body)) {
                echo "<p>Mail sent to $email.</p>\n";
                echo "<p><a href='./'>Go back</a>.</p>\n";
                return true;
            }
            else {
                echo "<p>An error occured while sending mail.</p>\n";
                echo "<p><a href='./'>Go back</a>.</p>\n";
                return false;
            }
        }
    }
    
    // Figure out what to do
    $users = parse_ini_file('users.ini', true);
    $string = (isset($_REQUEST['string']) ? $_REQUEST['string'] : '');
    
    // Show the edit-page if a valid id-string was given
    if (isset($users[$string])) {
        show_user($string, $users[$string]);
    }
    // If something resembling an email-address was given, send an email
    elseif (strpos($string, '@') !== false /* is an email address */) {
        $res = sendmail($string, $users);
    }
    // Show an error if something resembling an id-string was given
    elseif (strlen($string) == 9) {
        echo "<h1>Error</h1>\n";
        echo "<p>No user with that id exists. Maybe you just created yourself and haven't been approved yet? You will only be able to edit your entry once it's been approved.</p>\n";
        echo "<p><a href='./'>Go back</a>.</p>\n";
    }
    // Error if user entered garbage
    else {
        echo "<h1>Error</h1>\n";
        echo "<p>You didn't enter an email or a user-id. Go back and try again</p>";
        echo "<p><a href='./'>Go back</a>.</p>\n";
    }
?>

</body>
</html>
