<?php
/*
Copyright (c) 2006, Jonas Hggqvist
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
    $users = parse_ini_file('users.ini', true);
    function usersort($a, $b) {
        $a = strtolower((!empty($a['fullname']) ? $a['fullname'] : $a['alias']));
        $b = strtolower((!empty($b['fullname']) ? $b['fullname'] : $b['alias']));
        if ($a == $b) {
            return 0;
        }
        return ($a < $b) ? -1 : 1;
    }
    usort($users, 'usersort');
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>People map</title>

<link rel="stylesheet" href="map.css" />

<style type="text/css">
</style>

<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php echo file_get_contents('key.txt'); ?>"
      type="text/javascript"></script>
      
<script src="common.js" type="text/javascript"></script>
<script src="main.js" type="text/javascript"></script>

<script type="text/javascript">
//<![CDATA[
var map;
var user;
var dev;

function setup() {
    createIcons();
<?php
    foreach ($users as $id => $details) {
        printf("\n    var point = new GLatLng(%f,%f);\n", $details['lat'], $details['lng']);
        printf("    var text = \"\";\n");
        if (!empty($details['fullname']))
            printf('    text = text + "<b>%s</b>"'.";\n", $details['fullname']);
        if (!empty($details['alias']))
            printf('    text = text + "<br />%s"'.";\n", $details['alias']);
        if (!empty($details['url']))
            printf('    text = text + "<br /><a href=\'%s\'>Homepage</a>"'.";\n", $details['url'], $details['url']);
        if (!empty($details['dev']))
            printf("    map.addOverlay(createMarker(point, text, dev));\n");
        else
            printf("    map.addOverlay(createMarker(point, text, user));\n");
    }
?>
}

//]]>
</script>

</head>
<body onload="newload();setup()" onunload="GUnload()">
<h1>People map</h1>

<h2>Add yourself</h2>
<p><a href="add.php">Go here</a> to add yourself to the map.</p>
<h2>The people</h2>
<a name="maptop"></a>
<div id="gmap" style="width: 500px; height: 300px"></div>
<p>
<a href="#maptop" onclick='fullWindow()' id="full">Full window</a>
<a href="#maptop" onclick='smallWindow()' id="small" style="display: none">Small window</a>
</p>
<p>
<img src="http://labs.google.com/ridefinder/images/mm_20_red.png">User
<img src="http://labs.google.com/ridefinder/images/mm_20_blue.png">Developer - 
Click on a name below to center the map on this person.
</p>
<?php
    echo "<ul>\n";
    foreach($users as $id => $details) {
        $class = (empty($details['dev']) ? 'user' : 'dev');
        if (!empty($details['fullname']) && !empty($details['alias']))
            // Print both
            printf("<li class='%s'><a href='#' onClick='moveTo(%f,%f)'>%s</a> (%s)</li>\n", $class, $details['lng'], $details['lat'], $details['fullname'], $details['alias']);
        elseif (!empty($details['fullname']))
            // Print fullname
            printf("<li class='%s'><a href='#' onClick='moveTo(%f,%f)'>%s</a></li>\n", $class, $details['lng'], $details['lat'], $details['fullname']);
        else
            printf("<li class='%s'><a href='#' onClick='moveTo(%f,%f)'>%s</a></li>\n", $class, $details['lng'], $details['lat'], $details['alias']);
    }
    echo "</ul>\n";
    echo "<p>".sizeof($users)." rockbox users.</p>\n";
?>
<h2>Edit your entry</h2>
<p>
Enter the key that was given to you when you added your entry below. If you no
longer have it, you can enter your email and it will be sent to you.
</p>

<form method="post" action="edit.php">
Key or email: <input type="text" name="string">
<input type="submit" value="Edit">
</form>

</body>
</html>
