<?php
/*
Copyright (c) 2006, Jonas Hggqvist
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
    $username = '';
    $password = '';
    if (empty($username) || empty($password)) {
        echo "No username or password set, aborting.";
        die();
    }

    if (!isset($_SERVER['PHP_AUTH_USER'])) {
        header('WWW-Authenticate: Basic realm="Rockbox people moderation"');
        header('HTTP/1.0 401 Unauthorized');
        echo '<p>You need to enter the correct user/password to be here.</p>';
        die();
    }
    elseif ($_SERVER['PHP_AUTH_USER'] == $username && $_SERVER['PHP_AUTH_PW'] == $password) {
        $changes = parse_ini_file('changes.ini', true);
        $users = parse_ini_file('users.ini', true);
        $mgs = '';
        if (isset($_REQUEST['cmd'])) {
            // Detect if there were changes since last reload, do nothing if
            // there was
            if ($_REQUEST['time'] < filemtime('changes.ini')) {
                $msg = "<p style='color: red; font-size: larger'>Changes since last reload! Please try again.</p>\n";
            }
            else {
                // Add all accepted users to the users array
                if (is_array($_REQUEST['acc'])) {
                    foreach($_REQUEST['acc'] as $id => $val) {
                        if ($val == 'on') {
                            $users[$id] = $changes[$id];
                        }
                    }
                }
                
                // Write the entire users array to users.ini
                $fp = fopen('users.ini', 'w');
                foreach ($users as $id => $user) {
                        fwrite($fp, sprintf("[%s]\n", $id));
                        fwrite($fp, sprintf('  lng = "%f"'."\n", $user['lng']));
                        fwrite($fp, sprintf('  lat = "%f"'."\n", $user['lat']));
                        fwrite($fp, sprintf('  alias = "%s"'."\n", $user['alias']));
                        fwrite($fp, sprintf('  url = "%s"'."\n", $user['url']));
                        fwrite($fp, sprintf('  fullname = "%s"'."\n", $user['fullname']));
                        fwrite($fp, sprintf('  email = "%s"'."\n", $user['email']));
                        fwrite($fp, sprintf('  dev = "%s"'."\n", $user['dev']));
                        fwrite($fp, sprintf('  ip = "%s"'."\n\n", $user['ip']));
                }
                fclose($fp);
                
                // Truncate changes.ini (any user not accepted will be deleted)
                $fp = fopen('changes.ini', 'w');
                fclose($fp);
            }
        }
        $users = parse_ini_file('changes.ini', true);
    }
    else {
        echo '<p>You need to enter the correct user/password to be here.</p>';
        die();
    }  
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>People map</title>

<link rel="stylesheet" href="map.css" />

<style type="text/css">
.changedrow td {
    background-color: lightyellow;
}
.new td {
    background-color: lightgreen;
}

.unchanged {
    color: lightgrey;
}

.changed {
    font-weight: bolder;
}

</style>

<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php echo file_get_contents('key.txt'); ?>"
      type="text/javascript"></script>
<script src="common.js" type="text/javascript"></script>
<script src="main.js" type="text/javascript"></script>

<script type="text/javascript">

//<![CDATA[
var map;
var user;
var dev;

function setup() {
    createIcons();
<?php
    foreach ($users as $id => $details) {
        printf("\n    var point = new GLatLng(%f,%f);\n", $details['lat'], $details['lng']);
        printf('    var text = "<b>%s</b>"'.";\n", $details['alias']);
        if (!empty($details['fullname']))
            printf('    text = text + "<br />%s"'.";\n", $details['fullname']);
        if (!empty($details['url']))
            printf('    text = text + "<br /><a href=\'%s\'>Homepage</a>"'.";\n", $details['url'], $details['url']);
        if (!empty($details['dev']))
            printf("    map.addOverlay(createMarker(point, text, dev));\n");
        else
            printf("    map.addOverlay(createMarker(point, text, user));\n");
    }
?>
}

//]]>
</script>

</head>
<body onload="newload();setup()" onunload="GUnload()">
<h1>People</h1>
<p><a href='./'>Go back</a>.</p>
<p><a href='moderate.php'>Reload</a>.</p>
<?php echo $msg; ?>
<a name="maptop"></a>
<div id="gmap" style="width: 500px; height: 300px"></div>
<p>
<a href="#maptop" onclick='fullWindow()' id="full">Full window</a>
<a href="#maptop" onclick='smallWindow()' id="small" style="display: none">Small window</a>
</p>

<h2>People</h2>
<form action="moderate.php" method="post">
<input type="hidden" name="cmd" value="moderate">
<table>
    <tr>
    <thead>
        <td>Alias</td>
        <td>Full name</td>
        <td>Email</td>
        <td>URL</td>
        <td>IP</td>
        <td>Latitude</td>
        <td>Longitude</td>
        <td>Developer</td>
        <td>Accept</td>
    </thead>
    </tr>

<?php
    $approved = parse_ini_file('users.ini', true);
    printf("<input type='hidden' name='time' value='%d' />\n", time());
    foreach($users as $id => $details) {
        $link = sprintf("<a href='#' onclick='moveTo(%f,%f)'>", $details['lng'], $details['lat']);
        if (isset($approved[$id]))
            echo "<tr class='changedrow'>\n";
        else
            echo "<tr class='new'>\n";

        if (isset($approved[$id]) && $approved[$id]['alias'] == $details['alias'])
            echo "<td class='unchanged'>".$link.$details['alias']."</a></td>\n";
        else
            echo "<td class='changed'>".$link.$details['alias']."</a></td>\n";
            
        if (isset($approved[$id]) && $approved[$id]['fullname'] == $details['fullname'])
            echo "<td class='unchanged'>".$link.$details['fullname']."</a></td>\n";
        else
            echo "<td class='changed'>".$link.$details['fullname']."</a></td>\n";

        if (isset($approved[$id]) && $approved[$id]['email'] == $details['email'])
            echo "<td class='unchanged'>".$details['email']."</td>\n";
        else
            echo "<td class='changed'>".$details['email']."</td>\n";

        if (isset($approved[$id]) && $approved[$id]['url'] == $details['url'])
            echo "<td class='unchanged'>".$details['url']."</td>\n";
        else
            echo "<td class='changed'>".$details['url']."</td>\n";

        if (isset($approved[$id]) && $approved[$id]['ip'] == $details['ip'])
            echo "<td class='unchanged'>".$details['ip']."</td>\n";
        else
            echo "<td class='changed'>".$details['ip']."</td>\n";

        if (isset($approved[$id]) && $approved[$id]['lat'] == $details['lat'])
            echo "<td class='unchanged'>".$details['lat']."</td>\n";
        else
            echo "<td class='changed'>".$details['lat']."</td>\n";

        if (isset($approved[$id]) && $approved[$id]['lng'] == $details['lng'])
            echo "<td class='unchanged'>".$details['lng']."</td>\n";
        else
            echo "<td class='changed'>".$details['lng']."</td>\n";

        if (isset($approved[$id]) && $approved[$id]['dev'] == $details['dev'])
            echo "<td class='unchanged'>".$details['dev']."</td>\n";
        else
            echo "<td class='changed'>".$details['dev']."</td>\n";

        echo "<td><input type='checkbox' name='acc[$id]'></td>\n";
        echo "</tr>\n";
        
    }
?>

<tr><td colspan="9" align="right">
<input type='submit' value='Accept & Reject' />
</td></tr>
</table>
</form>
</body>
</html>
