<?php
/*
Copyright (c) 2006, Jonas Hggqvist
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.
    * Neither the name of the <ORGANIZATION> nor the names of its contributors
      may be used to endorse or promote products derived from this software
      without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>People map</title>

<link rel="stylesheet" href="map.css" />

</head>
<body>
<h1>Save user</h1>
<p><a href="./">Go back</a>.</p>

<?php
    function createid() {
        //$key = md5(uniqid(rand(), true));
        $key = '';
        for ($i = 0; $i < 5; $i++) {
        	$key .= chr(rand(65, 90));
        }
        $key .= '-';
        $key .= rand(100, 999);
        
        return $key;
    }
    
    function cleanup($string) {
        return htmlspecialchars($string);
    }

    function add_user($id) {
        $users = parse_ini_file('changes.ini', true);
        $user = array(
            lng => str_replace(',', '.', $_REQUEST['lng']),
            lat => str_replace(',', '.', $_REQUEST['lat']),
            alias => cleanup($_REQUEST['alias']),
            url => cleanup($_REQUEST['url']),
            fullname => cleanup($_REQUEST['fullname']),
            email => cleanup($_REQUEST['email']),
            dev => cleanup($_REQUEST['dev']),
            ip => $_SERVER['REMOTE_ADDR'],
        );
        $users[$id] = $user;
        $fp = fopen('changes.ini', 'w');
        foreach($users as $id => $user) {
            fwrite($fp, sprintf("[%s]\n", $id));
            fwrite($fp, sprintf('  lng = "%f"'."\n", $user['lng']));
            fwrite($fp, sprintf('  lat = "%f"'."\n", $user['lat']));
            fwrite($fp, sprintf('  alias = "%s"'."\n", $user['alias']));
            fwrite($fp, sprintf('  url = "%s"'."\n", $user['url']));
            fwrite($fp, sprintf('  fullname = "%s"'."\n", $user['fullname']));
            fwrite($fp, sprintf('  email = "%s"'."\n", $user['email']));
            fwrite($fp, sprintf('  dev = "%s"'."\n", $user['dev']));
            fwrite($fp, sprintf('  ip = "%s"'."\n\n", $user['ip']));
        }
        fclose($fp);
    }
    
    function log_string($string) {
        $log = fopen('log.txt', 'a');
        fwrite($log, sprintf("%s %s\n", date('r'), $string));
        fclose($log);
    }
    
    $users = parse_ini_file('users.ini', true);
    
    // User entered neither alias nor fullname  
    if (empty($_REQUEST['alias']) && empty($_REQUEST['fullname'])) {
        echo "<p>You need to enter at least one of either alias or full name. If you don't want to give out your real name, just put something in the Alias field.</p>\n";
        log_string("No alias or fullname: " . $_SERVER['REMOTE_ADDR']);
    }
    // Check that latitude and longitude are numbers (replacing , with .)
    elseif (!is_numeric(str_replace(',', '.', $_REQUEST['lat'])) || !is_numeric(str_replace(',', '.', $_REQUEST['lng']))) {
        echo "<p>Latitude or longitude was not a number. Please go back and correct.</p>\n";
        log_string("Lat or long NaN: " . $_SERVER['REMOTE_ADDR']);
    }
    // Check if user is performing an update
    elseif (isset($_REQUEST['id'])) {
        // Check if the given id actually exists
        if (isset($users[$_REQUEST['id']])) {
            // Add the user, effectively overwriting the old one
            add_user($_REQUEST['id']);
            echo "<p>Your update has been recorded, and will be effective once it's been approved.</p>\n";
            log_string("Update recorded: " . $_REQUEST['id']);
        }
        else {
            echo "<p>An error occured.</p>\n";
            log_string("Some other error: " . $_SERVER['REMOTE_ADDR']);
        }
    }
    else {
        // Create a unique key
        do { $key = createid(); } while (isset($users[$key]));
        add_user($key);
        echo "<p>You have been added. Your entry will appear once it's been approved. Your key is \"$key\". Keep this if you want to change your entry later on.</p>\n";
        log_string("User added: " . $key);
    }
?>

</body>
</html>
